--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/customreports.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/customreports.php	2025-06-27 11:43:40.346063000 +0000
@@ -1,6 +1,6 @@
 <?php
-/* Copyright (C) 2020-2024	Laurent Destailleur		<eldy@users.sourceforge.net>
- * Copyright (C) 2024-2025	MDW						<mdeweerd@users.noreply.github.com>
+/* Copyright (C) 2020-2024 Laurent Destailleur  <eldy@users.sourceforge.net>
+ * Copyright (C) 2024-2025	MDW					<mdeweerd@users.noreply.github.com>
  * Copyright (C) 2024		Frédéric France			<frederic.france@free.fr>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -39,10 +39,7 @@
  * @var Translate $langs
  * @var User $user
  *
- * @var ?int[]	$toselect  			Items selected on page, only used to see if not empty here
- * @var ?int	$SHOWLEGEND			Show legend or not
- * @var	string	$customreportkey	Custom report key
- * @var string	$customsql			Custom SQL
+ * @var ?int[]	$toselect  Items selected on page, only used to see if not empty here
  */
 '
 @phan-var-force ?int[] $toselect
@@ -92,6 +89,8 @@
 	$pageprev = $page - 1;
 	$pagenext = $page + 1;
 
+	$diroutputmassaction = $conf->user->dir_temp.'/'.$user->id.'/customreport';
+
 	$object = null;
 } else {
 	// When included into a main page
@@ -129,7 +128,7 @@
 if (!empty($object)) {
 	$objecttype = $object->element.($object->module ? '@'.$object->module : '');
 }
-if ((!is_string($objecttype) || empty($objecttype)) && isModEnabled('societe')) {
+if (!is_string($objecttype) || empty($objecttype)) {
 	$objecttype = 'thirdparty';
 }
 '@phan-var-force string $objecttype';  // Help phan that suggests $objecttype can be null
@@ -159,13 +158,12 @@
 $ObjectClassName = '';
 // Objects available by default
 $arrayoftype = array(
-	'thirdparty' => array('label' => 'ThirdParties', 'picto' => 'company', 'ObjectClassName' => 'Societe', 'enabled' => isModEnabled('societe'), 'ClassPath' => "/societe/class/societe.class.php", 'langs' => 'companies'),
+	'thirdparty' => array('langs' => 'companies', 'label' => 'ThirdParties', 'picto' => 'company', 'ObjectClassName' => 'Societe', 'enabled' => isModEnabled('societe'), 'ClassPath' => "/societe/class/societe.class.php"),
 	'contact' => array('label' => 'Contacts', 'picto' => 'contact', 'ObjectClassName' => 'Contact', 'enabled' => isModEnabled('societe'), 'ClassPath' => "/contact/class/contact.class.php"),
-	'proposal' => array('label' => 'Proposals', 'picto' => 'proposal', 'ObjectClassName' => 'Propal', 'enabled' => isModEnabled('propal'), 'ClassPath' => "/comm/propal/class/propal.class.php", 'langs' => 'propal'),
-	'order' => array('label' => 'Orders', 'picto' => 'order', 'ObjectClassName' => 'Commande', 'enabled' => isModEnabled('order'), 'ClassPath' => "/commande/class/commande.class.php", 'langs' => 'orders'),
-	'orderdet' => array('label' => 'SaleOrderLines', 'picto' => 'order', 'ObjectClassName' => 'OrderLine', 'enabled' => isModEnabled('order'), 'ClassPath' => "/commande/class/orderline.class.php", 'langs' => 'orders'),
-	'invoice' => array('label' => 'Invoices', 'picto' => 'bill', 'ObjectClassName' => 'Facture', 'enabled' => isModEnabled('invoice'), 'ClassPath' => "/compta/facture/class/facture.class.php", 'langs' => 'bills'),
-	'invoice_template' => array('label' => 'PredefinedInvoices', 'picto' => 'bill', 'ObjectClassName' => 'FactureRec', 'enabled' => isModEnabled('invoice'), 'ClassPath' => "/compta/facture/class/facture-rec.class.php", 'langs' => 'bills'),
+	'proposal' => array('label' => 'Proposals', 'picto' => 'proposal', 'ObjectClassName' => 'Propal', 'enabled' => isModEnabled('propal'), 'ClassPath' => "/comm/propal/class/propal.class.php"),
+	'order' => array('label' => 'Orders', 'picto' => 'order', 'ObjectClassName' => 'Commande', 'enabled' => isModEnabled('order'), 'ClassPath' => "/commande/class/commande.class.php"),
+	'invoice' => array('langs' => 'facture', 'label' => 'Invoices', 'picto' => 'bill', 'ObjectClassName' => 'Facture', 'enabled' => isModEnabled('invoice'), 'ClassPath' => "/compta/facture/class/facture.class.php"),
+	'invoice_template' => array('label' => 'PredefinedInvoices', 'picto' => 'bill', 'ObjectClassName' => 'FactureRec', 'enabled' => isModEnabled('invoice'), 'ClassPath' => "/compta/class/facturerec.class.php", 'langs' => 'bills'),
 	'contract' => array('label' => 'Contracts', 'picto' => 'contract', 'ObjectClassName' => 'Contrat', 'enabled' => isModEnabled('contract'), 'ClassPath' => "/contrat/class/contrat.class.php", 'langs' => 'contracts'),
 	'contractdet' => array('label' => 'ContractLines', 'picto' => 'contract', 'ObjectClassName' => 'ContratLigne', 'enabled' => isModEnabled('contract'), 'ClassPath' => "/contrat/class/contrat.class.php", 'langs' => 'contracts'),
 	'bom' => array('label' => 'BOM', 'picto' => 'bom', 'ObjectClassName' => 'Bom', 'enabled' => isModEnabled('bom')),
@@ -211,7 +209,6 @@
 
 		if ($fileforclass !== null) {
 			dol_include_once($fileforclass);
-
 			$ObjectClassName = $arrayoftype[$objecttype]['ObjectClassName'];
 		}
 		if (!empty($ObjectClassName)) {
@@ -357,9 +354,10 @@
 	$features .= (empty($object->module) ? '' : '@'.$object->module);
 }
 
-// Security check
 restrictedArea($user, $features, 0, '');
 
+$error = 0;
+
 
 /*
  * Actions
@@ -386,7 +384,6 @@
 	}
 }
 
-// Define $newarrayoftype that is array of object available for report
 $newarrayoftype = array();
 foreach ($arrayoftype as $key => $val) {
 	if (dol_eval((string) $val['enabled'], 1, 1, '1')) {
@@ -638,8 +635,7 @@
 	// Select object
 	print '<div class="divadvancedsearchfield center floatnone">';
 	print '<div class="inline-block"><span class="opacitymedium">'.$langs->trans("StatisticsOn").'</span></div> ';
-
-	print $form->selectarray('objecttype', $newarrayoftype, $objecttype, 0, 0, 0, '', 1, 0, 0, '', 'minwidth250', 1, '', 0, 1);
+	print $form->selectarray('objecttype', $newarrayoftype, $objecttype, 0, 0, 0, '', 1, 0, 0, '', 'minwidth200', 1, '', 0, 1);
 	if (empty($conf->use_javascript_ajax)) {
 		print '<input type="submit" class="button buttongen button-save nomargintop" name="changeobjecttype" value="'.$langs->trans("Refresh").'">';
 	} else {
@@ -655,41 +651,40 @@
 	}
 	print '</div><div class="clearboth"></div>';
 
-	if (!empty($newarrayoftype)) {
-		// Filter (you can use param &show_search_component_params_hidden=1 for debug)
-		if (!empty($object)) {
-			print '<div class="divadvancedsearchfield">';
-			print $form->searchComponent(array($object->element => $object->fields), $search_component_params, array(), $search_component_params_hidden, $arrayoffilterfields);
-			print '</div>';
-		}
-
-		// YAxis (add measures into array)
-		$count = 0;
-		//var_dump($arrayofmesures);
-		print '<div class="divadvancedsearchfield clearboth">';
-		print '<div class="inline-block"><span class="fas fa-ruler-combined paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("Measures")).'"></span><span class="fas fa-caret-left caretleftaxis" title="'.dol_escape_htmltag($langs->trans("Measures")).'"></span></div>';
-		$simplearrayofmesures = array();
-		foreach ($arrayofmesures as $key => $val) {
-			$simplearrayofmesures[$key] = $arrayofmesures[$key]['label'];
-		}
-		print $form->multiselectarray('search_measures', $simplearrayofmesures, $search_measures, 0, 0, 'minwidth300 widthcentpercentminusx', 1, 0, '', '', $langs->transnoentitiesnoconv("Measures"));	// Fill the array $arrayofmeasures with possible fields
-		print '</div>';
-
-		// XAxis
-		$count = 0;
+	// Filter (you can use param &show_search_component_params_hidden=1 for debug)
+	if (!empty($object)) {
 		print '<div class="divadvancedsearchfield">';
-		print '<div class="inline-block"><span class="fas fa-ruler-combined paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("XAxis")).'"></span><span class="fas fa-caret-down caretdownaxis" title="'.dol_escape_htmltag($langs->trans("XAxis")).'"></span></div>';
-		//var_dump($arrayofxaxis);
-		print $formother->selectXAxisField($object, $search_xaxis, $arrayofxaxis, $langs->trans("XAxis"), 'minwidth300 maxwidth400 widthcentpercentminusx');	// Fill the array $arrayofxaxis with possible fields
+		print $form->searchComponent(array($object->element => $object->fields), $search_component_params, array(), $search_component_params_hidden, $arrayoffilterfields);
 		print '</div>';
+	}
 
-		// Group by
-		$count = 0;
-		print '<div class="divadvancedsearchfield">';
-		print '<div class="inline-block opacitymedium"><span class="fas fa-ruler-horizontal paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("GroupBy")).'"></span></div>';
-		print $formother->selectGroupByField($object, $search_groupby, $arrayofgroupby, 'minwidth250 maxwidth300 widthcentpercentminusx', $langs->trans("GroupBy"));	// Fill the array $arrayofgroupby with possible fields
-		print '</div>';
+	// YAxis (add measures into array)
+	$count = 0;
+	//var_dump($arrayofmesures);
+	print '<div class="divadvancedsearchfield clearboth">';
+	print '<div class="inline-block"><span class="fas fa-ruler-combined paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("Measures")).'"></span><span class="fas fa-caret-left caretleftaxis" title="'.dol_escape_htmltag($langs->trans("Measures")).'"></span></div>';
+	$simplearrayofmesures = array();
+	foreach ($arrayofmesures as $key => $val) {
+		$simplearrayofmesures[$key] = $arrayofmesures[$key]['label'];
 	}
+	print $form->multiselectarray('search_measures', $simplearrayofmesures, $search_measures, 0, 0, 'minwidth300 widthcentpercentminusx', 1, 0, '', '', $langs->transnoentitiesnoconv("Measures"));	// Fill the array $arrayofmeasures with possible fields
+	print '</div>';
+
+	// XAxis
+	$count = 0;
+	print '<div class="divadvancedsearchfield">';
+	print '<div class="inline-block"><span class="fas fa-ruler-combined paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("XAxis")).'"></span><span class="fas fa-caret-down caretdownaxis" title="'.dol_escape_htmltag($langs->trans("XAxis")).'"></span></div>';
+	//var_dump($arrayofxaxis);
+	print $formother->selectXAxisField($object, $search_xaxis, $arrayofxaxis, $langs->trans("XAxis"), 'minwidth300 maxwidth400 widthcentpercentminusx');	// Fill the array $arrayofxaxis with possible fields
+	print '</div>';
+
+	// Group by
+	$count = 0;
+	print '<div class="divadvancedsearchfield">';
+	print '<div class="inline-block opacitymedium"><span class="fas fa-ruler-horizontal paddingright pictofixedwidth" title="'.dol_escape_htmltag($langs->trans("GroupBy")).'"></span></div>';
+	print $formother->selectGroupByField($object, $search_groupby, $arrayofgroupby, 'minwidth250 maxwidth300 widthcentpercentminusx', $langs->trans("GroupBy"));	// Fill the array $arrayofgroupby with possible fields
+	print '</div>';
+
 
 	if ($mode == 'grid') {
 		// YAxis
@@ -752,12 +747,13 @@
 		print '</div>';
 	}
 
-	if (!empty($newarrayoftype)) {
-		print '<div class="divadvancedsearchfield">';
-		print '<input type="submit" class="button buttongen button-save nomargintop" value="'.$langs->trans("Refresh").'">';
-		print '</div>';
-	}
+	//if ($mode == 'graph') {
+	//
+	//}
 
+	print '<div class="divadvancedsearchfield">';
+	print '<input type="submit" class="button buttongen button-save nomargintop" value="'.$langs->trans("Refresh").'">';
+	print '</div>';
 	print '</div>';
 	print '</form>';
 }
@@ -1221,10 +1217,6 @@
 print '<!-- Section to show the result -->'."\n";
 print '<div class="customreportsoutput'.($totalnbofrecord ? '' : ' customreportsoutputnotdata').'">';
 
-if (empty($newarrayoftype)) {
-	$langs->load("admin");
-	print info_admin($langs->trans("NoSupportedModulesHaveBeenActivated"), 0, 0, 'warning');
-}
 
 if ($mode == 'grid') {
 	// TODO

########## core/js/lib_head.js.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/js/lib_head.js.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/js/lib_head.js.php	2025-06-27 11:43:40.363090000 +0000
@@ -677,11 +677,6 @@
 		});
 		if (forcereload) {
 			var url = window.location.href;
-
-			/* reset action param */
-			url = url.replace(/action=\w+/g, '');
-
-			/* reset dol_resetcache param */
 			if (url.indexOf('dol_resetcache') < 0) {
 				if (url.indexOf('?') > -1) {
 					url = url + "&dol_resetcache=1";
@@ -689,8 +684,6 @@
 					url = url + "?dol_resetcache=1";
 				}
 			}
-
-			/* reset page_y param */
 			var page_y = $(document).scrollTop();
 			url = url.replace(/page_y=\d+/g, '');
 			if (page_y > 0) {

########## core/lib/admin.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/lib/admin.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/lib/admin.lib.php	2025-06-27 11:43:41.383895000 +0000
@@ -1575,7 +1575,7 @@
  */
 function activateModulesRequiredByCountry($country_code)
 {
-	global $db;
+	global $db, $conf, $langs;
 
 	$modulesdir = dolGetModulesDirs();
 
@@ -1736,8 +1736,8 @@
 /**
  *	Show array with constants to edit
  *
- *	@param	array<string,array{type:string,label:string,tooltip?:string}>|array<int,string>	$tableau		Array of constants array('key'=>array('type'=>type, 'label'=>label, 'tooltip'=>tooltip)
- *                                                                                          				where type can be 'string', 'text', 'textarea', 'html', 'yesno', 'emailtemplate:xxx', ...
+ *	@param	array<string,array{type:string,label:string}>|array<int,string>	$tableau		Array of constants array('key'=>array('type'=>type, 'label'=>label)
+ *                                                                                          where type can be 'string', 'text', 'textarea', 'html', 'yesno', 'emailtemplate:xxx', ...
  *	@param	int<2,3>	$strictw3c		0=Include form into table (deprecated), 1=Form is outside table to respect W3C (deprecated), 2=No form nor button at all, 3=No form nor button at all and each field has a unique name (form is output by caller, recommended)  (typed as int<2,3> to highlight the deprecated values)
  *  @param  string  	$helptext       Tooltip help to use for the column name of values
  *  @param	string		$text			Text to use for the column name of values

########## core/lib/agenda.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/lib/agenda.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/lib/agenda.lib.php	2025-06-27 11:43:41.385902000 +0000
@@ -104,7 +104,7 @@
 		// Assigned to user
 		print '<div class="divsearchfield">';
 		print img_picto($langs->trans("ActionsToDoBy"), 'user', 'class="pictofixedwidth inline-block"');
-		print $form->select_dolusers($filtert, 'search_filtert', 1, null, (int) !$canedit, '', '', '0', 0, 0, '', 2, '', 'minwidth100 maxwidth250 widthcentpercentminusx');
+		print $form->select_dolusers($filtert, 'search_filtert', 1, null, (int) !$canedit, '', '', '0', 0, 0, '', 0, '', 'minwidth100 maxwidth250 widthcentpercentminusx');
 		print '</div>';
 
 		// Assigned to user group

########## core/lib/company.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/lib/company.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/lib/company.lib.php	2025-06-27 11:43:41.398161000 +0000
@@ -219,7 +219,7 @@
 
 		$servicestatus = 0;
 		if (isModEnabled('stripe')) {
-			if (getDolGlobalString('STRIPE_LIVE')/* && !GETPOST('forcesandbox', 'alpha')*/) {
+			if (getDolGlobalString('STRIPE_LIVE') && !GETPOST('forcesandbox', 'alpha')) {
 				$servicestatus = 1;
 			}
 
@@ -1399,10 +1399,10 @@
 		$param .= '&search_note_private='.urlencode($search_note_private);
 	}
 	if ($search_birthday_dtstart != '') {
-		$param .= '&search_birthday_dtstart='.urlencode((string) $search_birthday_dtstart);
+		$param .= '&search_birthday_dtstart='.urlencode($search_birthday_dtstart);
 	}
 	if ($search_birthday_dtend != '') {
-		$param .= '&search_birthday_dtend='.urlencode((string) $search_birthday_dtend);
+		$param .= '&search_birthday_dtend='.urlencode($search_birthday_dtend);
 	}
 	if ($optioncss != '') {
 		$param .= '&optioncss='.urlencode($optioncss);
@@ -1657,7 +1657,7 @@
 			// Photo - Name
 			if (!empty($arrayfields['t.name']['checked'])) {
 				print '<td class="tdoverflowmax150">';
-				print $form->showphoto('contact', $contactstatic, 0, 0, 0, 'photorefnoborder valignmiddle marginrightonly', 'small', 1, 0, 'user');
+				print $form->showphoto('contact', $contactstatic, 0, 0, 0, 'photorefnoborder valignmiddle marginrightonly', 'small', 1, 0, '1');
 				print $contactstatic->getNomUrl(0, '', 0, '&backtopage='.urlencode($backtopage));
 				print '</td>';
 			}

########## core/lib/date.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/lib/date.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/lib/date.lib.php	2025-06-27 11:43:41.295081000 +0000
@@ -1334,35 +1334,16 @@
 		return 'ErrorBadParameter_num_open_day';
 	}
 
+	//print 'num_open_day timestampStart='.$timestampStart.' timestampEnd='.$timestampEnd.' bit='.$lastday;
 	if ($timestampStart < $timestampEnd) {
-		// --- 1. Calculate Gross Working Days ---
-		// Gross working days = total days in range - non-working days (weekends & public holidays).
-		$nbOpenDay = num_between_day($timestampStart, $timestampEnd, $lastday) - num_public_holiday($timestampStart, $timestampEnd, $country_code, $lastday);
+		$numdays = num_between_day($timestampStart, $timestampEnd, $lastday);
 
-		// --- 2. Apply Contextual Half-Day Deductions ---
-		$halfday = (int) $halfday; // Ensure $halfday is an integer for reliable comparisons.
-
-		// Check if start/end days are working days just ONCE to optimize performance
-		// by avoiding redundant calls to the potentially slow num_public_holiday() function.
-		$isStartDayWorking = (num_public_holiday($timestampStart, $timestampStart, $country_code, 1) == 0);
-		$isEndDayWorking   = (num_public_holiday($timestampEnd, $timestampEnd, $country_code, 1) == 0);
-
-		// Deduct 0.5 if the leave starts in the afternoon of a working day.
-		if (($halfday == -1 || $halfday == 2) && $isStartDayWorking) {
-			$nbOpenDay -= 0.5;
-		}
-
-		// Deduct 0.5 if the leave ends in the morning of a different, working day.
-		if (($halfday == 1 || $halfday == 2) && date('Y-m-d', $timestampStart) != date('Y-m-d', $timestampEnd) && $isEndDayWorking) {
-			$nbOpenDay -= 0.5;
+		$numholidays = num_public_holiday($timestampStart, $timestampEnd, $country_code, $lastday);
+		$nbOpenDay = ($numdays - $numholidays);
+		if ($inhour == 1 && $nbOpenDay <= 3) {
+			$nbOpenDay *= 24;
 		}
-
-		// --- 3. Return Final Value ---
-		if ($inhour == 1) {
-			return $nbOpenDay * 24;
-		}
-
-		return $nbOpenDay;
+		return $nbOpenDay - (($inhour == 1 ? 12 : 0.5) * abs($halfday));
 	} elseif ($timestampStart == $timestampEnd) {
 		$numholidays = 0;
 		if ($lastday) {

########## core/lib/files.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/core/lib/files.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/core/lib/files.lib.php	2025-06-27 11:43:41.308113000 +0000
@@ -47,8 +47,8 @@
  * @param	string			$utf8_path     	Starting path from which to search. This is a full path.
  * @param	string			$types        	Can be "directories", "files", or "all"
  * @param	int				$recursive		Determines whether subdirectories are searched
- * @param	string|string[]	$filter        	Regex or Array of Regex filter to restrict list. The regex value must be escaped for '/' by doing preg_quote($var,'/'), since this char is used for preg_match function,
- *                  	                    but must NOT contains the start and end '/'. Filter is checked into basename only.
+ * @param	string			$filter        	Regex filter to restrict list. This regex value must be escaped for '/' by doing preg_quote($var,'/'), since this char is used for preg_match function,
+ *                  	                    but must not contains the start and end '/'. Filter is checked into basename only.
  * @param	string|string[]	$excludefilter  Array of Regex for exclude filter (example: array('(\.meta|_preview.*\.png)$','^\.')). Exclude is checked both into fullpath and into basename (So '^xxx' may exclude 'xxx/dirscanned/...' and dirscanned/xxx').
  * @param	string			$sortcriteria	Sort criteria ('','fullname','relativename','name','date','size')
  * @param	int 			$sortorder		Sort order (SORT_ASC, SORT_DESC)
@@ -66,39 +66,22 @@
 	global $object;
 
 	if ($recursive <= 1) {	// Avoid too verbose log
+		// Verify filters (only on first call to function)
+		$filters_ok = true;
 		$error_info = "";
-
-		// Verify filters (only on the first call of the function)
-		$filter_ok = true;
-		if (!is_array($filter)) {
-			if (strlen($filter) > 25000) {	// Note that limit depends on syntax of filter
-				dol_syslog("Value for filter is too large", LOG_ERR);
-				$filter_ok = false;
-			} else {
-				// Check that all '/' are escaped.
-				if ((int) preg_match('/(?:^|[^\\\\])\//', $filter) > 0) {
-					$excludefilter_ok = false;
-					$error_info .= " error='filter_has_unescaped_slash'";
-					dol_syslog("'$filter' has unescaped '/'", LOG_ERR);
-				}
-			}
-		}
-
 		// Ensure we have an array for the exclusions
-		$excludefilter_ok = true;
 		$exclude_array = ($excludefilter === null || $excludefilter === '') ? array() : (is_array($excludefilter) ? $excludefilter : array($excludefilter));
-		foreach ($exclude_array as $f) {
+		foreach ((array($filter) + $exclude_array) as $f) {
 			// Check that all '/' are escaped.
 			if ((int) preg_match('/(?:^|[^\\\\])\//', $f) > 0) {
-				$excludefilter_ok = false;
-				$error_info .= " error='excludefilter_has_unescaped_slash'";
+				$filters_ok = false;
+				$error_info .= " error='$f unescaped_slash'";
 				dol_syslog("'$f' has unescaped '/'", LOG_ERR);
 			}
 		}
-
-		dol_syslog("files.lib.php::dol_dir_list path=".$utf8_path." types=".$types." recursive=".$recursive." filter=".json_encode($filter)." excludefilter=".json_encode($excludefilter).$error_info);
-		// print 'xxx'."files.lib.php::dol_dir_list path=".$utf8_path." types=".$types." recursive=".$recursive." filter=".json_encode($filter)." excludefilter=".json_encode($exclude_array);
-		if (!$filter_ok || !$excludefilter_ok) {
+		dol_syslog("files.lib.php::dol_dir_list path=".$utf8_path." types=".$types." recursive=".$recursive." filter=".$filter." excludefilter=".json_encode($excludefilter).$error_info);
+		// print 'xxx'."files.lib.php::dol_dir_list path=".$utf8_path." types=".$types." recursive=".$recursive." filter=".$filter." excludefilter=".json_encode($exclude_array);
+		if (!$filters_ok) {
 			// Return empty array when filters are invalid
 			return array();
 		}
@@ -173,10 +156,11 @@
 					$utf8_file = $os_file;
 				}
 
+				$qualified = 1;
+
 				$utf8_fullpathfile = $utf8_path_cursor."/".$utf8_file;  // Temp variable for speed
 
 				// Check if file is qualified
-				$qualified = 1;
 				foreach ($excludefilterarray as $filt) {
 					if (preg_match('/'.$filt.'/i', $utf8_file) || preg_match('/'.$filt.'/i', $utf8_fullpathfile)) {
 						$qualified = 0;
@@ -201,28 +185,7 @@
 								$fileperm = dol_fileperm($utf8_fullpathfile);
 							}
 
-							$qualifiedforfilter = 0;
-							if (empty($filter)) {
-								$qualifiedforfilter = 1;
-							} else {
-								$testpregmatch = false;
-								if (is_array($filter)) {
-									$chunks = array_chunk($filter, 500);
-									foreach ($chunks as $chunk) {
-										$testpregmatch = preg_match('/'.implode('|', $chunk).'/i', $utf8_file);	// May failed if $filter too large
-										if ($testpregmatch) {
-											break;
-										}
-									}
-								} else {
-									$testpregmatch = preg_match('/'.$filter.'/i', $utf8_file);		// May failed if $filter too large
-								}
-								if ($testpregmatch) {
-									$qualifiedforfilter = 1;
-								}
-							}
-
-							if ($qualifiedforfilter) {	// We do not search key $filter into all $path, only into $file part
+							if (!$filter || preg_match('/'.$filter.'/i', $utf8_file)) {	// We do not search key $filter into all $path, only into $file part
 								$reg = array();
 								preg_match('/([^\/]+)\/[^\/]+$/', $utf8_fullpathfile, $reg);
 								$level1name = (isset($reg[1]) ? $reg[1] : '');
@@ -256,28 +219,7 @@
 							$filesize = dol_filesize($utf8_fullpathfile);
 						}
 
-						$qualifiedforfilter = 0;
-						if (empty($filter)) {
-							$qualifiedforfilter = 1;
-						} else {
-							$testpregmatch = false;
-							if (is_array($filter)) {
-								$chunks = array_chunk($filter, 500);
-								foreach ($chunks as $chunk) {
-									$testpregmatch = preg_match('/'.implode('|', $chunk).'/i', $utf8_file);	// May failed if $filter too large
-									if ($testpregmatch) {
-										break;
-									}
-								}
-							} else {
-								$testpregmatch = preg_match('/'.$filter.'/i', $utf8_file);		// May failed if $filter too large
-							}
-							if ($testpregmatch) {
-								$qualifiedforfilter = 1;
-							}
-						}
-
-						if ($qualifiedforfilter) {	// We do not search key $filter into all $path, only into $file part
+						if (!$filter || preg_match('/'.$filter.'/i', $utf8_file)) {	// We do not search key $filter into $utf8_path, only into $utf8_file
 							if (empty($nbsecondsold) || $filedate <= ($now - $nbsecondsold)) {
 								preg_match('/([^\/]+)\/[^\/]+$/', $utf8_fullpathfile, $reg);
 								$level1name = (isset($reg[1]) ? $reg[1] : '');
@@ -343,7 +285,7 @@
 		$sql .= ", description";
 	}
 	$sql .= " FROM ".MAIN_DB_PREFIX."ecm_files";
-	if (!empty($object->entity)) {
+	if (!empty($object->entity) && $object->entity != $conf->entity) {
 		$sql .= " WHERE entity = ".((int) $object->entity);
 	} else {
 		$sql .= " WHERE entity = ".((int) $conf->entity);
@@ -390,7 +332,6 @@
 					"acl" => $obj->acl,
 					"share" => $obj->share,
 					"description" => ($mode ? $obj->description : '')
-					// TODO Add 'content' with $mode == 2 ?
 				);
 			}
 			$i++;
@@ -464,7 +405,6 @@
 	//var_dump($relativedir);
 	//var_dump($filearray);
 	//var_dump($filearrayindatabase);
-	//var_dump($object->entity);
 
 	// Complete filearray with properties found into $filearrayindatabase
 	foreach ($filearray as $key => $val) {
@@ -496,7 +436,6 @@
 
 			if (!preg_match('/([\\/]temp[\\/]|[\\/]thumbs|\.meta$)/', $rel_filename)) {     // If not a tmp file
 				dol_syslog("list_of_documents We found a file called '".$filearray[$key]['name']."' not indexed into database. We add it");
-
 				include_once DOL_DOCUMENT_ROOT.'/ecm/class/ecmfiles.class.php';
 				$ecmfile = new EcmFiles($db);
 
@@ -513,10 +452,6 @@
 				$ecmfile->gen_or_uploaded = 'unknown';
 				$ecmfile->description = ''; // indexed content
 				$ecmfile->keywords = ''; // keyword content
-				// When you scan file with dol_dir_list_in_database, you scan for files in entity of object (like with projects), even if you
-				// are connected into another entity. So we must also create record that was not found into the entity scan, so the one of the object).
-				$ecmfile->entity = empty($object->entity) ? $conf->entity : $object->entity;
-
 				$result = $ecmfile->create($user);
 				if ($result < 0) {
 					setEventMessages($ecmfile->error, $ecmfile->errors, 'warnings');

########## core/lib/ftp.lib.php
